#include <bits/stdc++.h>
#define MOD 1000000007
using namespace std;



int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n,k;
    vector<int> a;
    vector<long long> pom;
    vector<long long> g;
    cin>>n>>k;

    for(int i=0;i<n;i++){
        int x;
        cin>>x;
        a.push_back(x);
    }

    long long gore=1,dole=1;
    for(int i=0;i<k;i++){
        dole*=(i+1);
        dole%=MOD;
    }

    gore=dole;
    for(int i=1;i<=n;i++){
       g.push_back(gore/dole);
       gore/=i;
       gore*=(i+k);
       gore%=MOD;
        if(k==0)g[i-1]=1;
    }
   long long sum=0;
   for(int i=0;i<n;i++){
        long long x=(g[i]*g[n-i-1])%MOD;

        sum+=(x*a[i])%MOD;
        sum%=MOD;
   }
   cout<<sum<<endl;

return 0;
}